<?php

namespace Drupal\cmlexchange\Form;

use Drupal\Core\Form\FormBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Ajax\AjaxResponse;
use Drupal\Core\Ajax\HtmlCommand;
use Drupal\cmlexchange\Controller\ImportPipeline;

/**
 * Implements the form controller.
 */
class Import extends FormBase {
  private $wrapper = 'cml-import-wrapper';

  /**
   * AJAX ajaxPrev.
   */
  public function ajaxSubmit(array &$form, $form_state) {
    $otvet = "import:\n";
    $importer = new ImportPipeline();
    $otvet .= $importer->process($form_state->extra);
    $response = new AjaxResponse();
    $response->addCommand(new HtmlCommand("#" . $this->wrapper, "<pre>{$otvet}</pre>"));
    return $response;
  }

  /**
   * Build the simple form.
   */
  public function buildForm(array $form, FormStateInterface $form_state, $extra = NULL) {
    $form_state->extra = $extra;
    $form_state->setCached(FALSE);
    $form["import"] = [
      '#value' => $this->t('Import'),
      '#type' => 'submit',
      '#ajax'   => [
        'callback' => '::ajaxSubmit',
        'effect'   => 'fade',
        'progress' => ['type' => 'throbber', 'message' => NULL],
      ],
      '#suffix' => '<div id="' . $this->wrapper . '"></div>',
    ];
    return $form;
  }

  /**
   * Implements a form submit handler.
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    $form_state->setRebuild(TRUE);
  }

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'cml-import';
  }

}
